SXPTOC = 30100;
SXPVER = SXPTOC.."-1.0";
local SXPTIME = 0;
local SXPH = 16;
local SXPW = 600;
local _G = _G;

SXP_Options = {
	["short"] = true,
	["exp"]   = true,
	["rep"]   = true,
	["level"] = 80,
}

SXP_FACTION_COLORS = {
	[0] = "FFFFFF",
	[1] = "CC4C38 ",
	[2] = "CC4C38 ",
	[3] = "BF4300 ",
	[4] = "E5B200 ",
	[5] = "009919 ",
	[6] = "009919 ",
	[7] = "009919 ",
	[8] = "009919 ",
};


--Create Main
sxpm = CreateFrame("Frame", "SimpleXPMain", UIParent);
sxpm:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
sxpm:SetPoint("TOP", UIParent, "TOP", 0, 0);
sxpm:SetHeight(SXPH);
sxpm:SetWidth(SXPW);

--Create Font String
sxpf = sxpm:CreateFontString("SimpleXPFont", "OVERLAY");
sxpf:SetFontObject(GameFontNormal);
sxpf:SetHeight(SXPH);
--sxpf:SetWidth(SXPW);
sxpf:SetAllPoints(sxpm);

--Create Background
sxpt = sxpm:CreateTexture("SimpleXPTexture", "BACKGROUND");
sxpt:SetHeight(SXPH);
sxpt:SetWidth(SXPW);
sxpt:SetAllPoints(sxpm);
sxpt:SetTexture(0, 0, 0, 0.5);

--print("SimpleXP: Loaded "..SXPVER);

function SimpleXP_OnUpdate(self, elapsed)
	SXPTIME = SXPTIME + elapsed;
	local experience = "";
	local reputation = "";
	
	if SXPTIME > 1 then
		-- Experience
		if SXP_Options["exp"] and UnitLevel("player") ~= SXP_Options["level"] then
			local xp = UnitXP("player");
			local mx = UnitXPMax("player");
			local color = "|cffFF00FF ";
			local ender = " |r";
			local xps = xp;
			local mxs = mx;
			
			if SXP_Options["short"] then
				if xp >= 1000 then
					xps = math.floor(xp/1000).."k";
				end
				
				if mx >= 1000 then
					mxs = math.floor(mx/1000).."k";
				end
			end
			
			local fraction = xps.." / "..mxs;
			local percent  = " ("..math.floor((xp/mx)*100).."%) ";
			
			local rested = "";
			if GetXPExhaustion() then
				rested = " (+"..(GetXPExhaustion()/2)..")";
				color = "|cff0000FF";
			end
			
			experience = color..fraction..percent..rested..ender;
		end
		
		--Reputation
		if SXP_Options["rep"] then
			local name, standing, minrep, maxrep, value = GetWatchedFactionInfo()
			if name then
				local color = "|cff"..SXP_FACTION_COLORS[standing];
				local ender = " |r ";
				value = value - minrep;
				local limit = maxrep - minrep;
				local fraction = " "..value.." / "..limit;
				local percent  = " ("..math.floor((value/limit)*100).."%) ";
				local stand = "";
				
				if standing == 0 then
					stand = "(Unknown)";
				elseif standing == 1 then
					stand = "(Hated)";
				elseif standing == 2 then
					stand = "(Hostile)";
				elseif standing == 3 then
					stand = "(Unfriendly)";
				elseif standing == 4 then
					stand = "(Nuetral)";
				elseif standing == 5 then
					stand = "(Friendly)";
				elseif standing == 6 then
					stand = "(Honored)";
				elseif standing == 7 then
					stand = "(Revered)";
				elseif standing == 8 then
					stand = "(Exalted)";
				end
				
				reputation = color..name..fraction..percent..stand..ender;
			end
		end
		
		_G["SimpleXPFont"]:SetText(experience..reputation);
		_G["SimpleXPFont"]:SetWidth(sxpf:GetWidth());
		_G["SimpleXPTexture"]:SetWidth(sxpf:GetWidth());
		
		SXPTIME = 0;
	end
end 